program TextScript_Convert_To_Bullet_List;

{.$APPTYPE CONSOLE }

{$R *.res}

uses
  // don't touch this:
  System.SysUtils,
  Winapi.Windows,

  // insert your used units here:
  System.Classes;
  //CodesiteLogging; // debug

// Don't touch this start **********************************************************
const
  TextMemMapName = 'TextMemMapFile'; // for data exchange with compiled text scripts

type
  TTextData = Packed Record
    StrData: Array [0 .. 99999999] of Char;
  end;

  PTTextData = ^TTextData;

var
  TextMapHandle: THandle;
  PTextData: PTTextData;
  ClipText: string;
// Don't touch this end ************************************************************

// Put your procedures, functions, variables, constants etc. here:

var
  sl: TStringList;
  i: Integer;
  ThisLine: string;

begin
  try
    // DON'T TOUCH THIS:
    // Create MapFile if not yet existing:
    TextMapHandle := CreateFileMapping($FFFFFFFF, nil, PAGE_READWRITE, 0, Sizeof(TTextData), TextMemMapName);
    try
      if TextMapHandle > 0 then
      begin
        // Open data from memory:
        PTextData := MapViewOfFile(TextMapHandle, FILE_MAP_ALL_ACCESS, 0, 0, 0);
        try
          if PTextData = nil then
          begin
            Writeln('Mapfile could not be opened');
            EXIT;
          end
          else
          begin
            ClipText := PTextData.StrData;
// Start here by manipulating ClipText: **************************************************************************

            if ClipText = '' then
              EXIT;

            sl := TStringList.Create;
            try
              sl.Text := ClipText;
              for i := sl.Count - 1 downto 0 do
              begin
                ThisLine := Trim(sl[i]);
                if ThisLine = '' then
                begin
                  sl.Delete(i);
                  CONTINUE;
                end;
                sl[i] := ' ' + ThisLine;
              end;
              ClipText := sl.Text;
            finally
              sl.Free;
            end;

            // Send back the manipulated text:
            Writeln(ClipText);

// End here manipulating ClipText: *******************************************************************************
    // DON'T TOUCH THIS:
          end;
        finally
          UnMapViewOfFile(PTextData);
        end;
      end
      else
      begin
        Writeln('Mapfile could not be created');
        EXIT;
      end;
    finally
      CloseHandle(TextMapHandle);
    end;
  except
    on E: Exception do
      Writeln(E.ClassName, ': ', E.Message);
  end;
end.
