program TextScript_Encrypt;

{.$APPTYPE CONSOLE }

{$R *.res}

uses
  // don't touch this:
  System.SysUtils, Winapi.Windows,
  // insert your used classes here:
  System.Classes;
  //CodesiteLogging; // debug

// Don't touch this start **********************************************************
const
  TextMemMapName = 'TextMemMapFile'; // for data exchange with compiled text scripts

type
  TTextData = Packed Record
    StrData: Array [0 .. 99999999] of Char;
  end;

  PTTextData = ^TTextData;

var
  TextMapHandle: THandle;
  PTextData: PTTextData;
  ClipText: string;
// Don't touch this end ************************************************************

// Put your procedures, functions, variables, constants etc. here:

const
  Codes64 = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz+/';

var
  //PWDSecurityString: string;
  sl: TStringList;
  i: Integer;

(*function GeneratePWDSecurityString: string;
var
  i, x: integer;
  s1, s2: string;
begin
  s1 := Codes64;
  s2 := '';
  for i := 0 to 15 do
  begin
    x := Random(Length(s1));
    x := Length(s1) - x;
    s2 := s2 + s1[x];
    s1 := Copy(s1, 1, x - 1) + Copy(s1, x + 1, Length(s1));
  end;
  Result := s2;
end;*)

function MakeRNDString(Chars: string; Count: Integer): string; inline;
var
  i, x: Integer;
begin
  Result := '';
  for i := 0 to Count - 1 do
  begin
    x := Length(Chars) - Random(Length(Chars));
    Result := Result + Chars[x];
    Chars := Copy(Chars, 1, x - 1) + Copy(Chars, x + 1, Length(Chars));
  end;
end;

function EncodePWDEx(Data, SecurityString: string; MinV: Integer = 0; MaxV: Integer = 5): string; inline;
var
  i, x: Integer;
  s1, s2, ss: string;
begin
  if MinV > MaxV then
  begin
    i := MinV;
    MinV := MaxV;
    MaxV := i;
  end;
  if MinV < 0 then
    MinV := 0;
  if MaxV > 100 then
    MaxV := 100;
  Result := '';
  if Length(SecurityString) < 16 then
    Exit;
  for i := 1 to Length(SecurityString) do
  begin
    s1 := Copy(SecurityString, i + 1, Length(SecurityString));
    if Pos(SecurityString[i], s1) > 0 then
      Exit;
    if Pos(SecurityString[i], Codes64) <= 0 then
      Exit;
  end;
  s1 := Codes64;
  s2 := '';
  for i := 1 to Length(SecurityString) do
  begin
    x := Pos(SecurityString[i], s1);
    if x > 0 then
      s1 := Copy(s1, 1, x - 1) + Copy(s1, x + 1, Length(s1));
  end;
  ss := SecurityString;
  for i := 1 to Length(Data) do
  begin
    s2 := s2 + ss[Ord(Data[i]) mod 16 + 1];
    ss := Copy(ss, Length(ss), 1) + Copy(ss, 1, Length(ss) - 1);
    s2 := s2 + ss[Ord(Data[i]) div 16 + 1];
    ss := Copy(ss, Length(ss), 1) + Copy(ss, 1, Length(ss) - 1);
  end;
  Result := MakeRNDString(s1, Random(MaxV - MinV) + MinV + 1);
  for i := 1 to Length(s2) do
    Result := Result + s2[i] + MakeRNDString(s1, Random(MaxV - MinV) + MinV);
end;

begin
  try
    // DON'T TOUCH THIS:
    // Create MapFile if not yet existing:
    TextMapHandle := CreateFileMapping($FFFFFFFF, nil, PAGE_READWRITE, 0, Sizeof(TTextData), TextMemMapName);
    try
      if TextMapHandle > 0 then
      begin
        // Open data from memory:
        PTextData := MapViewOfFile(TextMapHandle, FILE_MAP_ALL_ACCESS, 0, 0, 0);
        try
          if PTextData = nil then
          begin
            Writeln('Mapfile could not be opened');
            EXIT;
          end
          else
          begin
            ClipText := PTextData.StrData;
// Start here by manipulating ClipText: **************************************************************************

            (*Randomize;
            PWDSecurityString := GeneratePWDSecurityString;
            CodeSite.Send(PWDSecurityString);*)

            if ClipText = '' then
              EXIT;

            sl := TStringList.Create;
            try
              sl.Text := ClipText;
              for i := 0 to sl.Count - 1 do
              begin
                Randomize;
                sl[i] := EncodePWDEx(sl[i], 'QNl8j3MRHWgL6vUJ');
              end;
              ClipText := sl.Text;
            finally
              sl.Free;
            end;

            // Send back the manipulated text:
            Writeln(ClipText);

// End here manipulating ClipText: *******************************************************************************
    // DON'T TOUCH THIS:
          end;
        finally
          UnMapViewOfFile(PTextData);
        end;
      end
      else
      begin
        Writeln('Mapfile could not be created');
        EXIT;
      end;
    finally
      CloseHandle(TextMapHandle);
    end;
  except
    on E: Exception do
      Writeln(E.ClassName, ': ', E.Message);
  end;
end.
