program TextScript_Decrypt;

{.$APPTYPE CONSOLE }

{$R *.res}

uses
  // don't touch this:
  System.SysUtils, Winapi.Windows,
  // insert your used classes here:
  System.Classes;
  //CodesiteLogging; // debug

// Don't touch this start **********************************************************
const
  TextMemMapName = 'TextMemMapFile'; // for data exchange with compiled text scripts

type
  TTextData = Packed Record
    StrData: Array [0 .. 99999999] of Char;
  end;

  PTTextData = ^TTextData;

var
  TextMapHandle: THandle;
  PTextData: PTTextData;
  ClipText: string;
// Don't touch this end ************************************************************

// Put your procedures, functions, variables, constants etc. here:

const
  Codes64 = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz+/';

var
  sl: TStringList;
  i: Integer;

function DecodePWDEx(Data, SecurityString: string): string; inline;
var
  i, x, x2: Integer;
  s1, s2, ss: string;
begin
  Result := #1;
  if Length(SecurityString) < 16 then
    Exit;
  for i := 1 to Length(SecurityString) do
  begin
    s1 := Copy(SecurityString, i + 1, Length(SecurityString));
    if Pos(SecurityString[i], s1) > 0 then
      Exit;
    if Pos(SecurityString[i], Codes64) <= 0 then
      Exit;
  end;
  s1 := Codes64;
  s2 := '';
  ss := SecurityString;
  for i := 1 to Length(Data) do
    if Pos(Data[i], ss) > 0 then
      s2 := s2 + Data[i];
  Data := s2;
  s2 := '';
  if Length(Data) mod 2 <> 0 then
    Exit;
  for i := 0 to Length(Data) div 2 - 1 do
  begin
    x := Pos(Data[i * 2 + 1], ss) - 1;
    if x < 0 then
      Exit;
    ss := Copy(ss, Length(ss), 1) + Copy(ss, 1, Length(ss) - 1);
    x2 := Pos(Data[i * 2 + 2], ss) - 1;
    if x2 < 0 then
      Exit;
    x := x + x2 * 16;
    s2 := s2 + chr(x);
    ss := Copy(ss, Length(ss), 1) + Copy(ss, 1, Length(ss) - 1);
  end;
  Result := s2;
end;

begin
  try
    // DON'T TOUCH THIS:
    // Create MapFile if not yet existing:
    TextMapHandle := CreateFileMapping($FFFFFFFF, nil, PAGE_READWRITE, 0, Sizeof(TTextData), TextMemMapName);
    try
      if TextMapHandle > 0 then
      begin
        // Open data from memory:
        PTextData := MapViewOfFile(TextMapHandle, FILE_MAP_ALL_ACCESS, 0, 0, 0);
        try
          if PTextData = nil then
          begin
            Writeln('Mapfile could not be opened');
            EXIT;
          end
          else
          begin
            ClipText := PTextData.StrData;
// Start here by manipulating ClipText: **************************************************************************

            if ClipText = '' then
              EXIT;

            sl := TStringList.Create;
            try
              sl.Text := ClipText;
              for i := 0 to sl.Count - 1 do
                sl[i] := DecodePWDEx(sl[i], 'QNl8j3MRHWgL6vUJ');
              ClipText := sl.Text;
            finally
              sl.Free;
            end;

            // Send back the manipulated text:
            Writeln(ClipText);

// End here manipulating ClipText: *******************************************************************************
    // DON'T TOUCH THIS:
          end;
        finally
          UnMapViewOfFile(PTextData);
        end;
      end
      else
      begin
        Writeln('Mapfile could not be created');
        EXIT;
      end;
    finally
      CloseHandle(TextMapHandle);
    end;
  except
    on E: Exception do
      Writeln(E.ClassName, ': ', E.Message);
  end;
end.
